// File: TEST.PRG - uses OMENU.LIB which  has a restriction of
// two pull  down menus max and  ten pull down menu items max.
// The  version of OMENU.LIB  that is included with  this file
// has these restrictions built in. See the OMENU.REG file for
// more information.
//
// To compile from DOS:
//    clipper test /a /n /w /m
// To link with rtlink:
//    rtlink fi test lib oclip lib omenu
//
#include "inkey.ch"
#include "setcurs.ch"

#define NoOfItems  10  // total number of pull down menu items
#define NoOfMenus  2   // number of pull down menus

#define HEADSEP      ""
#define COLSEP       "  "
#define IS_LINKED( fn )  !( TYPE( fn ) == "U" )
MEMVAR xd, lMore

//
FUNCTION TEST()
//
LOCAL nKey := 0

//------------------------------------------------------------------
// The following code demonstrates how to set up the variable arrays
// that are passed to the menu object. This sequence would apply to
// all applications using OMENU.
//------------------------------------------------------------------
PRIVATE menus[ NoOfMenus ]    // menu bar items
PRIVATE starts[ NoOfMenus ]   // start positions for pull downs
PRIVATE pdItems[ NoOfItems ]  // the pull down menu items
PRIVATE prompts[ NoOfItems ]  // prompts for pull down items
PRIVATE fn[ NoOfItems ]       // corresponding functions for pull down items
PUBLIC lMore                  // Browser Loop control

// fill in the menu bar items
menus[1] = 'File'
menus[2] = 'Fu~nctions'

// File
starts[ 1 ] = 1  // first item is always 1
// fill in the pull down menu items
pdItems[ 1 ] = '~Open Database'
pdItems[ 2 ] = '~Close Database'
pdItems[ 3 ] = '~'  // this will create a SEPERATOR line
pdItems[ 4 ] = 'E~xit  Alt-X'
// functions for the pull down menu items
fn[ 1 ] = "asdf()"
fn[ 2 ] = "stub"
fn[ 3 ] = "stub"  // must include any function name fir pdItems[ 3 ] above
fn[ 4 ] = "quitToDos()"

// Functions
starts[ 2 ] = 5 // starts another pull down menu at fifth pdItems array
pdItems[ 5 ] = 'Set View'
pdItems[ 6 ] = 'Column Width'
pdItems[ 7 ] = 'Default View'
pdItems[ 8 ] = 'Locked Field'
pdItems[ 9 ] = 'test'
pdItems[ 10] = 'test'
fn[ 5 ] = "stub"
fn[ 6 ] = "stub"
fn[ 7 ] = "stub"
fn[ 8 ] = "stub"
fn[ 9 ] = "stub"
fn[ 10] = "stub"

prompts[ 1  ] = 'Open parts database file.'
prompts[ 2  ] = 'Close parts database file.'
prompts[ 3  ] = ''  // must include this for pdItems[ 3 ] = '~' above
prompts[ 4  ] = 'Quit program and return to DOS.'
prompts[ 5  ] = 'Set database browser view.'
prompts[ 6  ] = 'Set database browser column widths.'
prompts[ 7  ] = 'Set database browser defaults column widths.'
prompts[ 8  ] = 'Set database browser locked field.'
prompts[ 9  ] = 'Execute STUB function.'
prompts[ 10 ] = 'Execute STUB function.'

CLEAR SCREEN
SETCANCEL(.T.)
SETCURSOR( SC_NONE ) // turn off the cursor

// declare a public menu object. This can be private but you
// must maintain its visibility.
PUBLIC xd := objmenu():New( menus, pdItems, starts, fn, prompts )

// before anything can be done with the object, it must be initialized
// and it must be done right after the instantiation.
xd:init()

// start menu bar row at 1 because we will use prompts, default is 0
xd:mbRow = 1

// draw the desk top
xd:drawDeskTop()

// you would normally put the menu object's functions in a loop
DO WHILE .T.

   // wait for user input
   nKey = INKEY( 0 )

   // apply it to the menu object
   xd:key( nKey )

   // here we force our own key to activate menu
   IF nKey == K_F10

      // force 1st pull down menu if F10 is pressed
      xd:npdSelect = 1

      // enable the menu object
      xd:enableMenu()

   ENDIF

   // you can add more key tests here via IF or DO CASE

ENDDO
SET COLOR TO G/
CLEAR SCREEN
@ 10,00 say ""
SETCURSOR( SC_NORMAL )
RETURN NIL


//
PROCEDURE STUB()
//
LOCAL screensav := SAVESCREEN(11,16,14,66)
LOCAL colorsav  := SETCOLOR()
LOCAL cursorsav := SETCURSOR(0)
SET COLOR TO W+/R
@ 11,16,13,64 BOX "Ŀ "
SHADOW(11,16,13,64)
@ 12,24 SAY "STUB() executed, any key to return."
INKEY(0)
RESTSCREEN(11,16,14,66,screensav)
SETCOLOR(colorsav)
SETCURSOR(cursorsav)
RETURN
